## pir-8-emu 0.1.1

=== Makefile ===
# The MIT License (MIT)

# Copyright (c) 2019 Lounge<C++>

# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:

# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


include configMakefile


LDAR := $(PIC) $(LNCXXAR) $(foreach l,$(OS_LD_LIBS),-l$(l))
INCAR := $(foreach l,include,-isystem$(l))
SOURCES := $(sort $(wildcard $(SRCDIR)*.cpp $(SRCDIR)**/*.cpp $(SRCDIR)**/**/*.cpp $(SRCDIR)**/**/**/*.cpp))


.PHONY : all clean libs
.SECONDARY : $(foreach l,$(SOURCES),$(patsubst $(SRCDIR)%.cpp,$(OBJDIR)%$(OBJ),$(l)))


all : libs

clean :
	rm -rf $(OUTDIR)

libs : $(foreach l,$(SOURCES),$(patsubst $(SRCDIR)%.cpp,$(OUTDIR)$(PREDLL)%$(DLL),$(l)))


$(OUTDIR)$(PREDLL)%$(DLL) : $(OBJDIR)%$(OBJ)
	@mkdir -p $(dir $@)
	$(CXX) $(CXXAR) -o$@ $^ $(LDAR) -shared

$(OBJDIR)%$(OBJ) : $(SRCDIR)%.cpp
	@mkdir -p $(dir $@)
	$(CXX) $(CXXAR) $(INCAR) -c -o$@ $^

=== debian/changelog ===
pir-8-emu (0.1.1-5) unstable; urgency=medium

  * Fix host triple detection

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Mon, 24 Feb 2020 00:30:43 +0100

pir-8-emu (0.1.1-4) unstable; urgency=medium

  * Patch in simple binary for extracting shell completion files
  * Install completions for bash, zsh, and fish

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Sun, 23 Feb 2020 22:28:15 +0100

pir-8-emu (0.1.1-3) unstable; urgency=medium

  * Use debhelper overrides correctly

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Thu, 20 Feb 2020 03:39:49 +0100

pir-8-emu (0.1.1-2) unstable; urgency=medium

  * .desktop file for pir-8-emu
  * Extracted highest-res icon from the .ico

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Wed, 19 Feb 2020 19:11:52 +0100

pir-8-emu (0.1.1-1) unstable; urgency=medium

  * Initial release, upstream version 0.1.1

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Wed, 19 Feb 2020 15:16:50 +0100

=== debian/control ===
Source: pir-8-emu
Section: devel
Priority: optional
Maintainer: nabijaczleweli <nabijaczleweli@gmail.com>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://github.com/nabijaczleweli/pir-8-emu.deb.git
Vcs-Browser: https://github.com/nabijaczleweli/pir-8-emu.deb
Homepage: https://github.com/LoungeCPP/pir-8-emu
Tag: implemented-in::rust, role::program
Build-Depends: debhelper,
               bash-completion,
               libx11-dev,
               libbearlibterminal-dev,
               patchelf,
#              ronn,  too old, broken on my machine
#              rustc?

Package: pir-8-emu
Architecture: linux-any
Section: devel
Priority: optional
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Implementation of the pir-8 ISA – emulator
 The pir-8 ISA, available at, https://github.com/thecoshman/pir-8,
 describes a custom computer architecture,
 the hardware for which is to be assembled from raw transistors Soon™.
 .
 This package contains just the emulator,
 you will need precompiled binaries to run,
 or the pir-8-emu-binutils package, containing an assembler and disassembler;
 additionally, pir-8-emu-devel contains development headers for building
 emulated hardware components.

Package: pir-8-emu-binutils
Architecture: linux-any
Section: devel
Priority: optional
Recommends: pir-8-emu (= ${binary:Version}),
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Implementation of the pir-8 ISA – assembler and disassembler
 The pir-8 ISA, available at, https://github.com/thecoshman/pir-8,
 describes a custom computer architecture,
 the hardware for which is to be assembled from raw transistors Soon™.
 .
 This package contains the assembler and disassembler,
 see the pir-8-emu package for the emulator.

Package: pir-8-emu-devel
Architecture: linux-any
Section: devel
Priority: optional
Recommends: pir-8-emu (= ${binary:Version}),
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Implementation of the pir-8 ISA – hardware development headers
 The pir-8 ISA, available at, https://github.com/thecoshman/pir-8,
 describes a custom computer architecture,
 the hardware for which is to be assembled from raw transistors Soon™.
 .
 This package contains headers for developing (emulated) hardware components,
 for the emulator, residing in the pir-8-emu package.

=== debian/rules ===
#!/usr/bin/make -f


CARGO ?= cargo
RONN ?= ronn

OUTDIR_EMULATOR = $(CURDIR)/debian/pir-8-emu/
OUTDIR_BINUTILS = $(CURDIR)/debian/pir-8-emu-binutils/
OUTDIR_DEVEL    = $(CURDIR)/debian/pir-8-emu-devel/

# https://wiki.debian.org/Multiarch/Tuples#Supporting_interfaces
TRIPLE = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


override_dh_auto_build:
	mkdir -p completions
	$(RONN) --organization="Lounge<C++>" $(wildcard man/*.md)	
	$(MAKE)
	RUSTFLAGS=-g $(CARGO) build --release
	cd completions && ../target/release/pir-8-build-completions

override_dh_auto_install:
	mkdir -p $(foreach l,$(OUTDIR_EMULATOR) $(OUTDIR_BINUTILS),$(l)usr/bin $(l)usr/share/zsh/vendor-functions $(l)usr/share/fish/vendor_completions.d) $(OUTDIR_EMULATOR)usr/share/pixmaps $(OUTDIR_EMULATOR)usr/share/applications $(OUTDIR_DEVEL)usr/lib/$(TRIPLE)/pir-8-emu/handler-examples/ $(OUTDIR_DEVEL)usr $(foreach l,$(OUTDIR_EMULATOR) $(OUTDIR_BINUTILS) $(OUTDIR_DEVEL),$(l)usr/share/pir-8-emu)
	@
	cp assets/pir-8-emu.ico debian/pir-8-emu.png $(OUTDIR_EMULATOR)usr/share/pixmaps/
	cp debian/pir-8-emu.desktop $(OUTDIR_EMULATOR)usr/share/applications/
	cp target/release/pir-8-emu $(OUTDIR_EMULATOR)usr/bin/
	@
	cp $(foreach l,as disasm,target/release/pir-8-$(l)) $(OUTDIR_BINUTILS)usr/bin/
	@
	cp -r include/          $(OUTDIR_DEVEL)usr/
	cp $(wildcard out/*.so) $(OUTDIR_DEVEL)usr/lib/$(TRIPLE)/pir-8-emu/handler-examples/
	@
	cp -r ext/pir-8/        $(OUTDIR_EMULATOR)usr/share/pir-8-emu/
	cp -r test-data/        $(OUTDIR_BINUTILS)usr/share/pir-8-emu/examples
	cp -r handler-examples/ $(OUTDIR_DEVEL)usr/share/pir-8-emu/
	@
	dh_bash-completion
	# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=921236#17
	cp completions/_pir-8-emu                         $(OUTDIR_EMULATOR)usr/share/zsh/vendor-functions/
	cp $(foreach l,as disasm,completions/_pir-8-$(l)) $(OUTDIR_BINUTILS)usr/share/zsh/vendor-functions/
	# # https://fishshell.com/docs/current/#where-to-put-completions
	cp completions/pir-8-emu.fish                         $(OUTDIR_EMULATOR)usr/share/fish/vendor_completions.d/
	cp $(foreach l,as disasm,completions/pir-8-$(l).fish) $(OUTDIR_BINUTILS)usr/share/fish/vendor_completions.d/

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_strip:
	# These binaries do not use BLT, but cargo still links them against it; dpkg-shlibdeps adds libbearlibterminal to Depends: and complains:
	# > dpkg-shlibdeps: warning: package could avoid a useless dependency if debian/pir-8-emu-binutils/usr/bin/pir-8-disasm debian/pir-8-emu-binutils/usr/bin/pir-8-as were not linked against libBearLibTerminal.so.0.15.7 (they use none of the library's symbols)
	patchelf --remove-needed $(shell ldd $(OUTDIR_BINUTILS)usr/bin/pir-8-as     | awk '/BearLibTerminal/ {print $$1}') $(OUTDIR_BINUTILS)usr/bin/pir-8-as
	patchelf --remove-needed $(shell ldd $(OUTDIR_BINUTILS)usr/bin/pir-8-disasm | awk '/BearLibTerminal/ {print $$1}') $(OUTDIR_BINUTILS)usr/bin/pir-8-disasm
	dh_strip

%:
	dh $@

## pir-8-emu 1.0.0

=== debian/changelog ===
pir-8-emu (1.0.0-2) unstable; urgency=medium

  * Fix Architecture from linux-any to any
  * Add emulator keyword to .desktop file
  * Fix typo in pir-8-as manpage
  * Fix most evil-mode lintian warnings, notably:
    + extra-license-file, by not installing LICENSE from ext/pir-8/;
    + package-uses-old-debhelper-compat-version, by bumping debhelper compat
      level to 12;
    + debian-watch-file-is-missing, by adding an explanatory one;

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Thu, 27 Feb 2020 23:27:36 +0100

pir-8-emu (1.0.0-1) unstable; urgency=medium

  * New upstream version 1.0.0

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Wed, 26 Feb 2020 20:12:58 +0100

pir-8-emu (0.1.1-6) unstable; urgency=medium

  * Move ISA to p8e-isa package, depended on by p8e and p8e-binutils
  * Add pir-8 changelog

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Tue, 25 Feb 2020 16:18:39 +0100

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
 Homepage: https://github.com/LoungeCPP/pir-8-emu
 Tag: implemented-in::rust, role::program
 Build-Depends: debhelper,
+               debhelper-compat (= 12),
                bash-completion,
                libx11-dev,
                libbearlibterminal-dev,
@@ -17,10 +18,9 @@
 #              rustc?
 
 Package: pir-8-emu
-Architecture: linux-any
-Section: devel
-Priority: optional
-Depends: ${misc:Depends},
+Architecture: any
+Depends: pir-8-emu-isa (= ${source:Version}),
+         ${misc:Depends},
          ${shlibs:Depends},
 Description: Implementation of the pir-8 ISA – emulator
  The pir-8 ISA, available at, https://github.com/thecoshman/pir-8,
@@ -34,11 +34,10 @@
  emulated hardware components.
 
 Package: pir-8-emu-binutils
-Architecture: linux-any
-Section: devel
-Priority: optional
+Architecture: any
 Recommends: pir-8-emu (= ${binary:Version}),
-Depends: ${misc:Depends},
+Depends: pir-8-emu-isa (= ${source:Version}),
+         ${misc:Depends},
          ${shlibs:Depends},
 Description: Implementation of the pir-8 ISA – assembler and disassembler
  The pir-8 ISA, available at, https://github.com/thecoshman/pir-8,
@@ -48,10 +47,23 @@
  This package contains the assembler and disassembler,
  see the pir-8-emu package for the emulator.
 
+Package: pir-8-emu-isa
+Architecture: all
+Suggests: pir-8-emu-binutils (= ${source:Version})
+Depends: ${misc:Depends},
+# https://www.debian.org/doc/debian-policy/ch-relationships.html#s-replaces
+Replaces: pir-8-emu (<< 0.1.1-6)
+Breaks: pir-8-emu (<< 0.1.1-6)
+Description: Implementation of the pir-8 ISA – Instruction Set Architecture
+ The pir-8 ISA, available at, https://github.com/thecoshman/pir-8,
+ describes a custom computer architecture,
+ the hardware for which is to be assembled from raw transistors Soon™.
+ .
+ This package contains the ISA targeted by pir-8-emu and pir-8-emu-binutils
+ version ${source:Version}.
+
 Package: pir-8-emu-devel
-Architecture: linux-any
-Section: devel
-Priority: optional
+Architecture: any
 Recommends: pir-8-emu (= ${binary:Version}),
 Depends: ${misc:Depends},
          ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,7 @@
 OUTDIR_EMULATOR = $(CURDIR)/debian/pir-8-emu/
 OUTDIR_BINUTILS = $(CURDIR)/debian/pir-8-emu-binutils/
 OUTDIR_DEVEL    = $(CURDIR)/debian/pir-8-emu-devel/
+OUTDIR_ISA      = $(CURDIR)/debian/pir-8-emu-isa/
 
 # https://wiki.debian.org/Multiarch/Tuples#Supporting_interfaces
 TRIPLE = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
@@ -20,7 +21,7 @@
 	cd completions && ../target/release/pir-8-build-completions
 
 override_dh_auto_install:
-	mkdir -p $(foreach l,$(OUTDIR_EMULATOR) $(OUTDIR_BINUTILS),$(l)usr/bin $(l)usr/share/zsh/vendor-functions $(l)usr/share/fish/vendor_completions.d) $(OUTDIR_EMULATOR)usr/share/pixmaps $(OUTDIR_EMULATOR)usr/share/applications $(OUTDIR_DEVEL)usr/lib/$(TRIPLE)/pir-8-emu/handler-examples/ $(OUTDIR_DEVEL)usr $(foreach l,$(OUTDIR_EMULATOR) $(OUTDIR_BINUTILS) $(OUTDIR_DEVEL),$(l)usr/share/pir-8-emu)
+	mkdir -p $(foreach l,$(OUTDIR_EMULATOR) $(OUTDIR_BINUTILS),$(l)usr/bin $(l)usr/share/zsh/vendor-functions $(l)usr/share/fish/vendor_completions.d) $(OUTDIR_EMULATOR)usr/share/pixmaps $(OUTDIR_EMULATOR)usr/share/applications $(OUTDIR_DEVEL)usr/lib/$(TRIPLE)/pir-8-emu/handler-examples/ $(OUTDIR_DEVEL)usr $(foreach l,$(OUTDIR_BINUTILS) $(OUTDIR_DEVEL) $(OUTDIR_ISA),$(l)usr/share/pir-8-emu)
 	@
 	cp assets/pir-8-emu.ico debian/pir-8-emu.png $(OUTDIR_EMULATOR)usr/share/pixmaps/
 	cp debian/pir-8-emu.desktop $(OUTDIR_EMULATOR)usr/share/applications/
@@ -31,9 +32,10 @@
 	cp -r include/          $(OUTDIR_DEVEL)usr/
 	cp $(wildcard out/*.so) $(OUTDIR_DEVEL)usr/lib/$(TRIPLE)/pir-8-emu/handler-examples/
 	@
-	cp -r ext/pir-8/        $(OUTDIR_EMULATOR)usr/share/pir-8-emu/
 	cp -r test-data/        $(OUTDIR_BINUTILS)usr/share/pir-8-emu/examples
 	cp -r handler-examples/ $(OUTDIR_DEVEL)usr/share/pir-8-emu/
+	cp -r ext/pir-8/        $(OUTDIR_ISA)usr/share/pir-8-emu/
+	rm                      $(OUTDIR_ISA)usr/share/pir-8-emu/pir-8/LICENSE
 	@
 	dh_bash-completion
 	# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=921236#17
@@ -43,8 +45,11 @@
 	cp completions/pir-8-emu.fish                         $(OUTDIR_EMULATOR)usr/share/fish/vendor_completions.d/
 	cp $(foreach l,as disasm,completions/pir-8-$(l).fish) $(OUTDIR_BINUTILS)usr/share/fish/vendor_completions.d/
 
+# changelog.pir-8:     git log --no-decorate --no-show-signature
+# changelog.pir-8-emu: for tag in $(git tag -l | tac); do git tag -ln1000 "$tag"; echo; echo; done | awk '!/[[:space:]]+\([[:alnum:]]{40}\)$/' | sed -re 's;\([[:alnum:]]{40}\);+;g' -e 's;\(#;(https://github.com/LoungeCPP/pir-8-emu/issues/;g' -e 's;\(@;(https://github.com/;g' | head -c -2
 override_dh_installchangelogs:
-	dh_installchangelogs debian/changelog.upstream
+	dh_installchangelogs -Npir-8-emu-isa debian/changelog.pir-8-emu
+	dh_installchangelogs -ppir-8-emu-isa debian/changelog.pir-8
 
 override_dh_strip:
 	# These binaries do not use BLT, but cargo still links them against it; dpkg-shlibdeps adds libbearlibterminal to Depends: and complains:

=== debian/watch ===
# The the tarball download from GitHub doesn't include the submodules,
#   git clone --recurse-submodules -b $latest_tag https://github.com/LoungeCPP/pir-8-emu.git pir-8-emu-$tag_without_v
#     && rm -rf pir-8-emu-$tag_without_v/{,pir-8/}.git
# and import that, then update changelogs as specified in debian/rules

version=4
# opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/pir-8-emu-$1\.tar\.gz/ \
#   https://github.com/LoungeCPP/pir-8-emu/releases .*/v?(\d\S+)\.tar\.gz

## pir-8-emu 2.0.0

=== debian/changelog ===
pir-8-emu (2.0.0-1) unstable; urgency=medium

  * Fix cleaning in d/rules
  * New upstream version 2.0.0
  * Rebase patches

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Sat, 29 Feb 2020 20:37:22 +0100

## pir-8-emu 2.0.1

=== debian/changelog ===
pir-8-emu (2.0.1-2) unstable; urgency=medium

  * Fix build defs to actually build in a clean sid chroot

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Sat, 07 Mar 2020 14:30:07 +0100

pir-8-emu (2.0.1-1) unstable; urgency=medium

  * New upstream version 2.0.1

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Tue, 03 Mar 2020 16:20:21 +0100

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,14 @@
 Build-Depends: debhelper,
                debhelper-compat (= 12),
                bash-completion,
+               ronn (>= 0.9.0),
+#              ^ ronn before that fails with regex+locale related errors
+               locales,
+#              ^ we need to generate some locales for ronn
+               cargo,
                libx11-dev,
                libbearlibterminal-dev,
                patchelf,
-#              ronn,  too old, broken on my machine
-#              rustc?
 
 Package: pir-8-emu
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -14,11 +14,12 @@
 
 
 override_dh_auto_build:
-	mkdir -p completions
-	$(RONN) --organization="Lounge<C++>" $(wildcard man/*.md)	
+	mkdir -p target/completions target/locales
+	localedef -i en_GB -c -f UTF-8 -A /usr/share/locale/locale.alias target/locales/en_GB.UTF-8
+	LOCPATH="target/locales/" LC_CTYPE="en_GB.UTF-8" $(RONN) -r --organization="Lounge<C++>" $(wildcard man/*.md)
 	$(MAKE)
 	RUSTFLAGS=-g $(CARGO) build --release
-	cd completions && ../target/release/pir-8-build-completions
+	cd target/completions && ../../target/release/pir-8-build-completions
 
 override_dh_auto_install:
 	mkdir -p $(foreach l,$(OUTDIR_EMULATOR) $(OUTDIR_BINUTILS),$(l)usr/bin $(l)usr/share/zsh/vendor-functions $(l)usr/share/fish/vendor_completions.d) $(OUTDIR_EMULATOR)usr/share/pixmaps $(OUTDIR_EMULATOR)usr/share/applications $(OUTDIR_DEVEL)usr/lib/$(TRIPLE)/pir-8-emu/handler-examples/ $(OUTDIR_DEVEL)usr $(foreach l,$(OUTDIR_BINUTILS) $(OUTDIR_DEVEL) $(OUTDIR_ISA),$(l)usr/share/pir-8-emu)
@@ -39,11 +40,15 @@
 	@
 	dh_bash-completion
 	# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=921236#17
-	cp completions/_pir-8-emu                         $(OUTDIR_EMULATOR)usr/share/zsh/vendor-functions/
-	cp $(foreach l,as disasm,completions/_pir-8-$(l)) $(OUTDIR_BINUTILS)usr/share/zsh/vendor-functions/
+	cp target/completions/_pir-8-emu                         $(OUTDIR_EMULATOR)usr/share/zsh/vendor-functions/
+	cp $(foreach l,as disasm,target/completions/_pir-8-$(l)) $(OUTDIR_BINUTILS)usr/share/zsh/vendor-functions/
 	# # https://fishshell.com/docs/current/#where-to-put-completions
-	cp completions/pir-8-emu.fish                         $(OUTDIR_EMULATOR)usr/share/fish/vendor_completions.d/
-	cp $(foreach l,as disasm,completions/pir-8-$(l).fish) $(OUTDIR_BINUTILS)usr/share/fish/vendor_completions.d/
+	cp target/completions/pir-8-emu.fish                         $(OUTDIR_EMULATOR)usr/share/fish/vendor_completions.d/
+	cp $(foreach l,as disasm,target/completions/pir-8-$(l).fish) $(OUTDIR_BINUTILS)usr/share/fish/vendor_completions.d/
+
+override_dh_auto_clean:
+	rm -rf target/ Cargo.lock $(wildcard man/*.1)
+	$(MAKE) clean
 
 # changelog.pir-8:     git log --no-decorate --no-show-signature
 # changelog.pir-8-emu: for tag in $(git tag -l | tac); do git tag -ln1000 "$tag"; echo; echo; done | awk '!/[[:space:]]+\([[:alnum:]]{40}\)$/' | sed -re 's;\([[:alnum:]]{40}\);+;g' -e 's;\(#;(https://github.com/LoungeCPP/pir-8-emu/issues/;g' -e 's;\(@;(https://github.com/;g' | head -c -2

## pir-8-emu 2.0.2

=== debian/changelog ===
pir-8-emu (2.0.2-1) unstable; urgency=medium

  * New upstream version 2.0.2

 -- nabijaczleweli <nabijaczleweli@gmail.com>  Fri, 13 Mar 2020 18:35:06 +0100
